module foo

  type, abstract :: base_type
  end type base_type

  type, extends (base_type) :: concrete_type
     procedure(fun), nopass, pointer :: f => null ()
  end type concrete_type

contains

  function fun () result (n)
    integer :: n
    n = 42
  end function fun

end module foo

program main

  use foo

  type(concrete_type) :: d1
  class(base_type), allocatable :: d0

  ! This is the non-polymorphic object
  d1%f => fun
  print *, d1%f ()

  ! This is the polymorphic object.
  ! However, inside the select type construct, it should behave
  ! like the non-polymorphic object.
  allocate (concrete_type :: d0)
  select type (d0)
  type is (concrete_type)
     d0%f => fun
     print *, d0%f ()
  end select

end program main


  
